SystemOrganization addCategory: #'MonticelloFileTree-Core'!

MCWriter subclass: #MCFileTreeAbstractStWriter
	instanceVariableNames: 'stWriter initializers orderedClassNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeAbstractStWriter class methodsFor: 'accessing' stamp: 'dkh 4/4/2012 15:06'!
monticelloMetaDirName
    ^ '.'! !

!MCFileTreeAbstractStWriter class methodsFor: 'writing' stamp: 'dkh 4/4/2012 14:31'!
on: aStream
    MCFileTreePackageStructureStWriter useCypressWriter
        ifTrue: [ ^ MCFileTreeStCypressWriter new stream: aStream ].
    ^ (MCFileTreePackageStructureStWriter useSnapShotWriter
        ifTrue: [ MCFileTreeStSnapshotWriter ]
        ifFalse: [ MCFileTreeStWriter ]) new stream: aStream! !

!MCFileTreeAbstractStWriter class methodsFor: 'accessing' stamp: 'dkh 2/16/2012 14:49:00'!
readerClass
	^ MCStReader! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 2/29/2012 15:41'!
directoryForDirectoryNamed: directoryNameOrPath
    ^ directoryNameOrPath = '.'
        ifTrue: [ stream packageFileDirectory ]
        ifFalse: [ stream subPackageFileDirectoryFor: directoryNameOrPath ]! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 3/2/2012 09:51'!
fileNameForSelector: selector
    ^ (selector == #'/'
        ifTrue: [ 'encoded slash' ]
        ifFalse: [ 
            (selector includes: $/)
                ifTrue: [ 'encoded' , selector copyReplaceAll: '/' with: ' slash ' ]
                ifFalse: [ selector ] ]) asString! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 2/16/2012 14:49:00'!
initialize
    stWriter := MCFileTreePackageStructureStWriter new
        initializers: (initializers := Set new);
        yourself.
    orderedClassNames := OrderedCollection new! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 4/4/2012 15:06'!
monticelloMetaDirName
    ^ self class monticelloMetaDirName! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 4/4/2012 12:01'!
setFileStream: file
    stWriter stream: file! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 2/29/2012 14:33'!
visitClassDefinition: definition
    self subclassResponsibility! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 2/16/2012 14:49:00'!
visitClassTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 2/29/2012 16:18'!
visitMetaclassDefinition: definition
    "handled by class definition"

    ! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 2/29/2012 14:34'!
visitMethodDefinition: definition
    self subclassResponsibility! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'CAmilloBruni 8/2/2012 18:51'!
visitOrganizationDefinition: defintion
    self
        writeInDirectoryName: self monticelloMetaDirName
        fileName: 'categories'
        extension: 'st'
        visit: [ defintion categories do: [ :cat | stWriter writeCategory: cat ] ]! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 2/16/2012 14:49:00'!
visitScriptDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 2/16/2012 14:49:00'!
visitTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 4/4/2012 11:31'!
writeBasicDefinitions: aCollection
    "the correct initialization order is unknown if some classes are missing in the image"

    self writePropertiesFile.
    stWriter acceptVisitor: self forDefinitions: aCollection.
    self writeInitializers! !

!MCFileTreeAbstractStWriter methodsFor: 'writing' stamp: 'dkh 2/29/2012 14:52'!
writeClassDefinition: definition
    stWriter writeClassDefinition: definition.
    definition hasClassInstanceVariables
        ifTrue: [ stWriter writeMetaclassDefinition: definition ].
    definition hasComment
        ifTrue: [ stWriter writeClassComment: definition ]! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 4/4/2012 11:31'!
writeDefinitions: aCollection
    "the correct initialization order is unknown if some classes are missing in the image"

    self writeBasicDefinitions: aCollection! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'CAmilloBruni 8/2/2012 18:51'!
writeInDirectoryName: directoryNameOrPath fileName: fileName extension: extension visit: visitBlock
	| file |	
	file := self directoryForDirectoryNamed: directoryNameOrPath.
	fileName isEmptyOrNil ifFalse: [ file := file / fileName ].
	file := file , extension.
	file writeStreamDo: [ :aStream | 
			aStream lineEndConvention: #'lf'.
			self setFileStream: aStream.
			visitBlock value ]! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'CAmilloBruni 8/2/2012 18:51'!
writeInitializers
    self
        writeInDirectoryName: self monticelloMetaDirName
        fileName: 'initializers'
        extension: 'st'
        visit: [ 
            stWriter
                writePresentInitializers;
                writeAbsentInitializers ]! !

!MCFileTreeAbstractStWriter methodsFor: 'writing' stamp: 'dkh 2/29/2012 14:53'!
writeMethodDefinition: definition
    stWriter visitMethodDefinition: definition! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'CAmilloBruni 8/2/2012 18:51'!
writePropertiesFile
    self
        writeInDirectoryName: '.'
        fileName: ''
        extension: 'filetree'
        visit: [ stWriter writeProperties ]! !

MCFileTreeAbstractStWriter subclass: #MCFileTreeStSnapshotWriter
	instanceVariableNames: 'classDefinitions methodDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeStSnapshotWriter subclass: #MCFileTreeStCypressWriter
	instanceVariableNames: 'fileStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeStCypressWriter class
	instanceVariableNames: 'specials'!

MCFileTreeStCypressWriter class
	instanceVariableNames: 'specials'!

!MCFileTreeStCypressWriter class methodsFor: 'initialization' stamp: 'dkh 5/23/2012 21:18:06'!
initialize
    "self initialize"

    "force initialization of specials ..."

    specials := nil! !

!MCFileTreeStCypressWriter class methodsFor: 'private' stamp: 'bf 7/4/2012 16:24'!
initializeSpecials
    | map |
    map := Dictionary new.
    map
        at: $+ put: 'plus';
        at: $- put: 'minus';
        at: $= put: 'equals';
        at: $< put: 'less';
        at: $> put: 'more';
        at: $% put: 'percent';
        at: $& put: 'and';
        at: $| put: 'pipe';
        at: $* put: 'star';
        at: $/ put: 'slash';
        at: $\ put: 'backslash';
        at: $~ put: 'tilde';
        at: $? put: 'wat';
        at: $, put: 'comma';
        at: $@ put: 'at'.
    map keys do: [ :key | map at: (map at: key) put: key ].
    ^ map
! !

!MCFileTreeStCypressWriter class methodsFor: 'accessing' stamp: 'dkh 4/4/2012 15:05'!
monticelloMetaDirName
    ^ 'monticello.meta'! !

!MCFileTreeStCypressWriter class methodsFor: 'accessing' stamp: 'dkh 4/4/2012 11:27'!
specials
    ^ specials ifNil: [ specials := self initializeSpecials ]! !

!MCFileTreeStCypressWriter methodsFor: 'private' stamp: 'dkh 4/4/2012 11:25'!
fileNameForSelector: selector
    ^ selector last = $:
        ifTrue: [ 
            selector
                collect: [ :each | 
                    each = $:
                        ifTrue: [ $. ]
                        ifFalse: [ each ] ] ]
        ifFalse: [ 
            selector first isLetter
                ifTrue: [ selector ]
                ifFalse: [ 
                    | output specials |
                    specials := self class specials.
                    output := String new writeStream.
                    output nextPut: $^.
                    selector do: [ :each | output nextPutAll: (specials at: each) ] separatedBy: [ output nextPut: $. ].
                    output contents ] ]! !

!MCFileTreeStCypressWriter methodsFor: 'private' stamp: 'dkh 4/4/2012 14:01'!
setFileStream: aStream
    super setFileStream: aStream.
    fileStream := aStream! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 10:01'!
writeClassComment: definition
    fileStream nextPutAll: definition comment withUnixLineEndings! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 7/10/2012 09:33'!
writeClassDefinition: definition
    | properties |
    properties := Dictionary new.
    properties at: 'name' put: definition className.
    properties at: 'super' put: definition superclassName.
    definition traitCompositionString
        ifNotNil: [ :property | 
            "Issue #48: https://github.com/dalehenrich/filetree/issues/48"
            property ~= '{}'
                ifTrue: [ properties at: 'traitcomposition' put: property ] ].
    definition classTraitCompositionString
        ifNotNil: [ :property | 
            "Issue #48: https://github.com/dalehenrich/filetree/issues/48"
            property ~= '{}'
                ifTrue: [ properties at: 'classtraitcomposition' put: property ] ].
    properties at: 'category' put: definition category.
    properties at: 'instvars' put: definition instVarNames asArray.
    properties at: 'classvars' put: definition classVarNames asArray.
    properties at: 'pools' put: definition poolDictionaries asArray.
    properties at: 'classinstvars' put: definition classInstVarNames asArray.
    properties at: 'type' put: definition type asString.
    properties at: 'commentStamp' put: definition commentStamp.
    properties writeCypressJsonOn: fileStream! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'CAmilloBruni 8/2/2012 18:51'!
writeClassDefinition: definition to: classPath
    self
        writeInDirectoryName: classPath
        fileName: 'README'
        extension: 'md'
        visit: [ self writeClassComment: definition ].
    self
        writeInDirectoryName: classPath
        fileName: 'properties'
        extension: 'json'
        visit: [ self writeClassDefinition: definition ].
    self
        writeInDirectoryName: classPath
        fileName: 'methodProperties'
        extension: 'json'
        visit: [ self writeMethodProperties: (self methodDefinitions at: definition className ifAbsent: [ #() ]) ]! !

!MCFileTreeStCypressWriter methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/15/2012 01:59'!
writeDefinitions: aCollection
    | classDirExtension extensionClasses extensionMethodDefinitions extensionMethodMap |
    self writeBasicDefinitions: aCollection.
    extensionClasses := OrderedCollection new.
    extensionMethodDefinitions := OrderedCollection new.
    self methodDefinitions
        keysAndValuesDo: [ :className :extensionMethods | 
            self classDefinitions
                at: className
                ifAbsent: [ 
                    extensionClasses add: className.
                    extensionMethodDefinitions addAll: extensionMethods ] ].
    extensionClasses do: [ :className | self methodDefinitions removeKey: className ].
    classDirExtension := '.class'.
    self classDefinitions
        keysAndValuesDo: [ :className :definition | 
            | classPath instanceMethodPath classMethodPath |
            classPath := definition className , classDirExtension , self slash.
            self writeClassDefinition: definition to: classPath.
            instanceMethodPath := classPath , 'instance' , self slash.
            classMethodPath := classPath , 'class' , self slash.
            (self methodDefinitions at: className ifAbsent: [ #() ])
                do: [ :methodDefinition | 
                    methodDefinition classIsMeta
                        ifTrue: [ self writeMethodDefinition: methodDefinition to: classMethodPath ]
                        ifFalse: [ self writeMethodDefinition: methodDefinition to: instanceMethodPath ] ] ].
    classDirExtension := '.extension'.
    extensionMethodMap := Dictionary new.
    extensionMethodDefinitions
        do: [ :methodDefinition | 
            | classPath methodPath |
            (extensionMethodMap
                at: methodDefinition className
                ifAbsent: [ extensionMethodMap at: methodDefinition className put: OrderedCollection new ])
                add: methodDefinition.
            classPath := methodDefinition className , classDirExtension , self slash.
            self writeExtensionClassDefinition: methodDefinition to: classPath.
            methodPath := classPath
                ,
                    (methodDefinition classIsMeta
                        ifTrue: [ 'class' ]
                        ifFalse: [ 'instance' ]) , self slash.
            self writeMethodDefinition: methodDefinition to: methodPath ].
    extensionMethodMap
        keysAndValuesDo: [ :className :classMethodDefinitions | 
            | classPath |
            classPath := className , classDirExtension , self slash.
            self
                writeInDirectoryName: classPath
                fileName: 'methodProperties'
                extension: 'json'
                visit: [ self writeMethodProperties: classMethodDefinitions ] ]! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/4/2012 17:52'!
writeExtensionClassDefinition: definition
    | properties |
    properties := Dictionary new.
    properties at: 'name' put: definition className.
    properties writeCypressJsonOn: fileStream! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'CAmilloBruni 8/2/2012 18:52'!
writeExtensionClassDefinition: definition to: classPath
    self
        writeInDirectoryName: classPath
        fileName: 'properties'
        extension: 'json'
        visit: [ self writeExtensionClassDefinition: definition ]! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 10:02'!
writeMethodDefinition: definition
    fileStream
        nextPutAll: definition category;
        lf;
        nextPutAll: definition source withUnixLineEndings! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'CAmilloBruni 8/2/2012 18:52'!
writeMethodDefinition: methodDefinition to: methodPath
    | filename |
    filename := self fileNameForSelector: methodDefinition selector.
    self
        writeInDirectoryName: methodPath
        fileName: filename
        extension: 'st'
        visit: [ self writeMethodDefinition: methodDefinition ]! !

!MCFileTreeStCypressWriter methodsFor: 'initialize-release' stamp: 'dkh 6/12/2012 17:33:23'!
writeMethodProperties: classMethodDefinitions
    "Issue 33: https://github.com/dalehenrich/filetree/issues/33"

    | properties classMethodsMap instanceMethodMap |
    properties := Dictionary new.
    properties at: 'class' put: (classMethodsMap := Dictionary new).
    properties at: 'instance' put: (instanceMethodMap := Dictionary new).
    classMethodDefinitions
        do: [ :methodDefinition | 
            (methodDefinition classIsMeta
                ifTrue: [ classMethodsMap ]
                ifFalse: [ instanceMethodMap ]) at: methodDefinition selector asString put: methodDefinition timeStamp ].
    properties writeCypressJsonOn: fileStream! !

!MCFileTreeStCypressWriter methodsFor: 'initialize-release' stamp: 'CAmilloBruni 8/2/2012 18:52'!
writePropertiesFile
    | properties |
    properties := Dictionary new.
    properties at: 'noMethodMetaData' put: true.
    properties at: 'separateMethodMetaAndSource' put: false.
    properties at: 'useCypressPropertiesFile' put: true.
    self
        writeInDirectoryName: '.'
        fileName: ''
        extension: 'filetree'
        visit: [ properties writeCypressJsonOn: fileStream ].
    self
        writeInDirectoryName: '.'
        fileName: 'properties'
        extension: 'json'
        visit: [ Dictionary new writeCypressJsonOn: fileStream ]! !

!MCFileTreeStSnapshotWriter methodsFor: 'accessing' stamp: 'dkh 2/29/2012 14:36'!
classDefinitions
    classDefinitions ifNil: [ classDefinitions := Dictionary new ].
    ^ classDefinitions! !

!MCFileTreeStSnapshotWriter methodsFor: 'accessing' stamp: 'dkh 2/29/2012 14:37'!
methodDefinitions
    methodDefinitions ifNil: [ methodDefinitions := Dictionary new ].
    ^ methodDefinitions! !

!MCFileTreeStSnapshotWriter methodsFor: 'accessing' stamp: 'CamilloBruni 9/15/2012 01:50'!
slash
	^ DiskStore delimiter ! !

!MCFileTreeStSnapshotWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:52'!
visitClassDefinition: definition
    orderedClassNames add: definition className.
    self classDefinitions at: definition className put: definition! !

!MCFileTreeStSnapshotWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:53'!
visitMethodDefinition: definition
    (self methodDefinitions
        at: definition className
        ifAbsent: [ self methodDefinitions at: definition className put: OrderedCollection new ]) add: definition! !

!MCFileTreeStSnapshotWriter methodsFor: 'writing' stamp: 'CAmilloBruni 8/2/2012 18:51'!
writeClassDefinition: definition to: classPath
    self
        writeInDirectoryName: classPath
        fileName: definition className
        extension: 'st'
        visit: [ self writeClassDefinition: definition ]! !

!MCFileTreeStSnapshotWriter methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/15/2012 01:58'!
writeDefinitions: aCollection
    | basePath extensionClasses extensionMethodDefinitions |
    self writeBasicDefinitions: aCollection.
    basePath := 'snapshot' , self slash , 'classes' , self slash.
    extensionClasses := OrderedCollection new.
    extensionMethodDefinitions := OrderedCollection new.
    self methodDefinitions
        keysAndValuesDo: [ :className :extensionMethods | 
            self classDefinitions
                at: className
                ifAbsent: [ 
                    extensionClasses add: className.
                    extensionMethodDefinitions addAll: extensionMethods ] ].

    extensionClasses do: [ :className | self methodDefinitions removeKey: className ].
    self classDefinitions
        keysAndValuesDo: [ :className :definition | 
            | classPath instanceMethodPath classMethodPath |
            classPath := basePath , definition className , '.class' , self slash.
            self writeClassDefinition: definition to: classPath.
            instanceMethodPath := classPath , 'instance' , self slash.
            classMethodPath := classPath , 'class' , self slash.
            (self methodDefinitions at: className ifAbsent: [ #() ])
                do: [ :methodDefinition | 
                    methodDefinition classIsMeta
                        ifTrue: [ self writeMethodDefinition: methodDefinition to: classMethodPath ]
                        ifFalse: [ self writeMethodDefinition: methodDefinition to: instanceMethodPath ] ] ].

    basePath := 'snapshot' , self slash , 'extensions' , self slash.
    extensionMethodDefinitions
        do: [ :methodDefinition | 
            | methodPath |
            methodPath := basePath , methodDefinition className , '.class' , self slash
                ,
                    (methodDefinition classIsMeta
                        ifTrue: [ 'class' ]
                        ifFalse: [ 'instance' ]) , self slash.
            self writeMethodDefinition: methodDefinition to: methodPath ]! !

!MCFileTreeStSnapshotWriter methodsFor: 'writing' stamp: 'CAmilloBruni 8/2/2012 18:51'!
writeMethodDefinition: methodDefinition to: methodPath
    | filename |
    filename := self fileNameForSelector: methodDefinition selector.
    self
        writeInDirectoryName: methodPath
        fileName: filename
        extension: 'st'
        visit: [ self writeMethodDefinition: methodDefinition ]! !

MCFileTreeAbstractStWriter subclass: #MCFileTreeStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'CAmilloBruni 8/2/2012 18:52'!
visitClassDefinition: definition
    orderedClassNames add: definition className.
    self
        writeInDirectoryName: definition className
        fileName: definition className
        extension: 'st'
        visit: [ self writeClassDefinition: definition ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'CAmilloBruni 8/2/2012 18:52'!
visitMethodDefinition: definition
    | filename directoryname |
    directoryname := definition classIsMeta
        ifTrue: [ definition className , '_class' ]
        ifFalse: [ definition className ].
    filename := self fileNameForSelector: definition selector.
    self
        writeInDirectoryName: directoryname
        fileName: filename
        extension: 'st'
        visit: [ self writeMethodDefinition: definition ]! !

!MCMethodDefinition methodsFor: '*monticellofiletree-core' stamp: 'dkh 2/16/2012 14:49:00'!
setTimeStamp: aString
    ^ timeStamp := aString! !

!MCFileRepositoryInspector methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/5/2012 11:15:15'!
refresh
	| packageNames |
	packageNames := Set new.
	packageList := nil.
	versions := repository retrieveVersionsWithPackageNames: packageNames.
	newer := Set new.
	inherited := Set new.
	loaded := Set new.
	MCWorkingCopy allManagers
		do: [ :each | 
			| latest |
			each ancestors
				do: [ :ancestor | 
					loaded add: ancestor name.
					ancestor
						ancestorsDoWhileTrue: [ :heir | 
							(inherited includes: heir name)
								ifTrue: [ false ]
								ifFalse: [ 
									inherited add: heir name.
									true ] ] ].
			latest := (versions select: [ :v | v first = each package name ]) detectMax: [ :v | v third ].
			(latest notNil
				and: [ 
					each ancestors
						allSatisfy: [ :ancestor | 
							| av |
							av := ((ancestor name copyAfterLast: $-) copyAfter: $.) asInteger.
							av < latest third
								or: [ av = latest third and: [ ((ancestor name copyAfterLast: $-) copyUpTo: $.) ~= latest second ] ] ] ])
				ifTrue: [ newer add: each package name ] ].	"		select: [ :each | packageNames includes: each packageName]"
	self
		changed: #packageList;
		changed: #versionList! !

!Number methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    aStream nextPutAll: self printString! !

!Dictionary methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonForHtmlOn: aStream
    self writeCypressJsonOn: aStream forHtml: true indent: 0! !

!Dictionary methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream
    self writeCypressJsonOn: aStream forHtml: false indent: 0.
    aStream lf! !

!Dictionary methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    | indent keys |
    indent := startIndent.
    aStream
        nextPutAll: '{';
        lf.
    indent := indent + 1.
    keys := self keys sort: [ :a :b | a <= b ].
    1 to: keys size do: [ :index | 
        | key value |
        key := keys at: index.
        value := self at: key.
        aStream tab: indent.
        key writeCypressJsonOn: aStream forHtml: forHtml indent: indent.
        aStream nextPutAll: ' : '.
        value writeCypressJsonOn: aStream forHtml: forHtml indent: indent.
        index < self size
            ifTrue: [ 
                aStream
                    nextPutAll: ',';
                    lf ] ].
    self size = 0
        ifTrue: [ aStream tab: indent ].
    aStream nextPutAll: ' }'! !

!MCRepository methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/5/2012 11:15:15'!
retrieveVersionsWithPackageNames: packageNames
    ^ self readableFileNames
        collect: [ :each | 
            | name |
            name := (each copyUpToLast: $.) copyUpTo: $(.
            name last isDigit
                ifFalse: [ 
                    Array
                        with: name
                        with: ''
                        with: ''
                        with: each ]
                ifTrue: [ 
                    Array
                        with: (packageNames add: (name copyUpToLast: $-))
                        with: ((name copyAfterLast: $-) copyUpTo: $.)
                        with: ((name copyAfterLast: $-) copyAfter: $.) asInteger
                        with: each	"pkg name"	"user"	"version" ] ]! !

MCMczReader subclass: #MCFileTreeAbstractReader
	instanceVariableNames: 'packageProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeAbstractReader class methodsFor: 'accessing' stamp: 'dkh 4/4/2012 17:43'!
monticelloMetaDirName
    ^ '.'! !

!MCFileTreeAbstractReader class methodsFor: 'reading' stamp: 'CamilloBruni 8/2/2012 15:48'!
on: aFileRefernence fileName: fileName
	^ super on: aFileRefernence / fileName ! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 12:09'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    self subclassResponsibility! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 19:00'!
addClassAndMethodDefinitionsFromDirectory: aFileReference timestamp: timestamp
	| entries |
	entries := (self separateMethodMetaAndSource or: [ self noMethodMetaData ])
						ifTrue: [ aFileReference entries select: [ :entry | entry basename endsWith: '.st' ] ]
						ifFalse: [ aFileReference entries ].
	entries do: [ :file | 
		| definition |
		(definition := self definitionFromFile: file inDirectory: aFileReference)
			ifNotNil: [ 
				definition isMethodDefinition
					ifTrue: [ 
						self separateMethodMetaAndSource
							ifTrue: [ 
								(aFileReference / definition selector asString , 'meta')
									readStreamDo: [ :fileStream | definition setTimeStamp: (Author fixStamp: fileStream contents) ] ].
						self noMethodMetaData
							ifTrue: [ definition setTimeStamp: timestamp ] ].
				definitions add: definition ] ]! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:34'!
addClassAndMethodDefinitionsFromDirectoryEntries: entries
	| timestamp |
	
	self noMethodMetaData
		ifTrue: [ timestamp := self info author , ' ' , self info date mmddyyyy , ' ' , self info time print24 ].
		
	entries
		select: [ :entry| entry isDirectory ]
        	thenDo: [ :element | 
                   self addClassAndMethodDefinitionsFromDirectory: element asFileReference timestamp:  timestamp ]! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 2/16/2012 14:49:00'!
addDefinitionFromFile: directoryEntry inDirectory: aDirectory
    (self definitionFromFile: directoryEntry inDirectory: aDirectory) ifNotNil: [ :def | definitions add: def ]! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 2/16/2012 14:49:00'!
basicVersion
	^ (MCVersion new)
		setPackage: self package
			info: self info
			snapshot: self snapshot
			dependencies: self dependencies;
		yourself! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:59'!
definitionFromFile: directoryEntry inDirectory: aDirectory
    | defs reader |
    directoryEntry ifNil: [ ^ nil ].
    (aDirectory / directoryEntry basename)
        readStreamDo: [ :fileStream | 
            | methodDefinition |
            reader := MCStReader on: fileStream.
            (defs := reader definitions) size <= 1
                ifFalse: [ self error: 'we should be writing exactly 1 definition per file' ] ].
    defs size = 0
        ifTrue: [ ^ nil ].
    ^ defs first! !

!MCFileTreeAbstractReader methodsFor: 'testing' stamp: 'CamilloBruni 8/2/2012 15:44'!
hasMonticelloMetadata
    ^ (self packageDirectory / MCFileTreeStCypressWriter monticelloMetaDirName) exists
        or: [(self packageDirectory / 'version') exists and: [(self packageDirectory / 'package') exists ]]! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:36'!
loadDefinitions
    | entries |
    definitions := OrderedCollection new.
    entries := self packageDirectory entries.
    self
        addDefinitionFromFile: (entries detect: [ :entry | entry basename beginsWith: 'categories' ] ifNone: [  ])
            inDirectory: self packageDirectory;
        addClassAndMethodDefinitionsFromDirectory: self packageDirectory;
        addDefinitionFromFile: (entries detect: [ :entry | entry basename beginsWith: 'initializers' ] ifNone: [  ])
            inDirectory: self packageDirectory! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:37'!
loadDependencies
    | dependencyDir |
    dependencyDir := self packageDirectory / self monticelloMetaDirName / 'dependencies'.
    dependencyDir exists
        ifFalse: [ ^ dependencies := #() ].
    dependencies := OrderedCollection new.
    dependencyDir entries
        do: [ :entry | 
            dependencies
                add:
                    (MCVersionDependency
                        package: (MCPackage named: entry basename)
                        info:
                            (self extractInfoFrom: (self parseMember: 'dependencies' , Path delimiter , entry basename))) ].
    dependencies := dependencies asArray! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 4/4/2012 17:43'!
monticelloMetaDirName
    ^ self class monticelloMetaDirName! !

!MCFileTreeAbstractReader methodsFor: 'testing' stamp: 'dkh 3/1/2012 10:11'!
noMethodMetaData
    ^ self packageProperties at: 'noMethodMetaData' ifAbsent: [ false ]! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'CamilloBruni 8/2/2012 15:44'!
packageDirectory
	^ stream! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'CamilloBruni 8/2/2012 15:44'!
packageDirectory: aFileReference
	stream := aFileReference! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'CAmilloBruni 8/2/2012 18:42'!
packageProperties
    packageProperties
        ifNil: [ 
            packageProperties := Dictionary new.
            (self packageDirectory entries detect: [ :entry | entry basename = '.filetree' ] ifNone: [  ])
                ifNotNil: [ :configEntry | 
                    configEntry asFileReference
                        readStreamDo: [ :fileStream | 
                            | jsonObject structureVersion |
                            [ 
                            (jsonObject := MCFileTreeJsonParser parseStream: fileStream) isFloat
                                ifTrue: [ 
                                    "
							0.0 - original structure
							0.1 - separate files for method metaData (timestamp) and source
							0.2 - no method metaData file"
                                    packageProperties := Dictionary new.
                                    structureVersion := jsonObject printShowingDecimalPlaces: 1.
                                    packageProperties at: 'noMethodMetaData' put: structureVersion = '0.2'.
                                    packageProperties at: 'separateMethodMetaAndSource' put: structureVersion = '0.1' ]
                                ifFalse: [ 
                                    packageProperties := jsonObject.
                                    ((packageProperties at: 'noMethodMetaData' ifAbsent: [ false ])
                                        and: [ packageProperties at: 'separateMethodMetaAndSource' ifAbsent: [ false ] ])
                                        ifTrue: [ self error: 'noMethodMetaData and separateMethodMetaAndSource cannot both be true' ] ] ]
                                on: Error
                                do: [ :ex | 
                                    Transcript
                                        cr;
                                        show:
                                                'Error reading package properties (.filetree): ' , self packageDirectory fullName , ' :: ' , ex description ] ] ] ].
    ^ packageProperties! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:42'!
parseMember: fileName
    | directory tokens contents |
    directory := self packageDirectory / self monticelloMetaDirName.
    contents := (directory / fileName) readStreamDo: [ :aStream | aStream contents ].
    tokens := (self scanner scanTokens: contents) first.
    ^ self associate: tokens! !

!MCFileTreeAbstractReader methodsFor: 'testing' stamp: 'dkh 3/1/2012 10:10'!
separateMethodMetaAndSource
    ^ self packageProperties at: 'separateMethodMetaAndSource' ifAbsent: [ false ]! !

MCFileTreeAbstractReader subclass: #MCFileTreeStReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStReader class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 12:04'!
extension
	^ 'tree'! !

!MCFileTreeStReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 12:18'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    self addClassAndMethodDefinitionsFromDirectoryEntries: aDirectory entries! !

MCFileTreeAbstractReader subclass: #MCFileTreeStSnapshotReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeStSnapshotReader subclass: #MCFileTreeStCypressReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStCypressReader class methodsFor: 'accessing' stamp: 'dkh 4/4/2012 14:19'!
extension
    ^ 'package'! !

!MCFileTreeStCypressReader class methodsFor: 'accessing' stamp: 'dkh 4/4/2012 17:44'!
monticelloMetaDirName
    ^ MCFileTreeStCypressWriter monticelloMetaDirName! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:36'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    aDirectory entries
        do: [ :entry | 
            (entry basename endsWith: '.class')
                ifTrue: [ self addClassAndMethodDefinitionsFromEntry: entry ].
            (entry basename endsWith: '.extension')
                ifTrue: [ self addExtensionClassAndMethodDefinitionsFromEntry: entry ] ]! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'CamilloBruni 8/2/2012 16:01'!
addClassAndMethodDefinitionsFromEntry: classEntry
	| classDirectory classPropertiesDict classComment entries methodPropertiesDict |
	
	classDirectory := classEntry asFileReference.
	
	((entries := classDirectory entries) detect: [ :entry | entry basename = 'properties.json' ] ifNone: [  ])
		ifNotNil: [ :propertyEntry | 
			propertyEntry asFileReference readStreamDo: [ :fileStream | 
				classPropertiesDict := MCFileTreeJsonParser parseStream: fileStream ]].
	
	(entries detect: [ :entry | entry basename = 'README.md' ] ifNone: [  ])
		ifNotNil: [ :commentEntry | 
			commentEntry asFileReference readStreamDo: [ :fileStream | 
				classComment := fileStream contents ]].
		
	methodPropertiesDict := Dictionary new.
	(entries detect: [ :entry | entry basename = 'methodProperties.json' ] ifNone: [  ])
		ifNotNil: [ :propertyEntry | 
			propertyEntry asFileReference	readStreamDo: [ :fileStream | 
				"Issue 33: https://github.com/dalehenrich/filetree/issues/33"
				methodPropertiesDict := MCFileTreeJsonParser parseStream: fileStream ]].
		
	self addClassDefinitionFrom: classPropertiesDict comment: classComment withSqueakLineEndings.
	self
		addMethodDefinitionsForClass: (classPropertiesDict at: 'name')
		methodProperties: methodPropertiesDict
		in: entries! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 6/27/2012 14:18'!
addClassDefinitionFrom: classPropertiesDict comment: classComment
    definitions
        add:
            (MCClassDefinition
                name: (classPropertiesDict at: 'name')
                superclassName: (classPropertiesDict at: 'super')
                traitComposition: (classPropertiesDict at: 'traitcomposition' ifAbsent: [ '{}' ])
                classTraitComposition: (classPropertiesDict at: 'classtraitcomposition' ifAbsent: [ '{}' ])
                category: (classPropertiesDict at: 'category' ifAbsent: [ self packageNameFromPackageDirectory ])
                instVarNames: (classPropertiesDict at: 'instvars' ifAbsent: [ #() ])
                classVarNames: (classPropertiesDict at: 'classvars' ifAbsent: [ #() ])
                poolDictionaryNames: (classPropertiesDict at: 'pools' ifAbsent: [ #() ])
                classInstVarNames: (classPropertiesDict at: 'classinstvars' ifAbsent: [ #() ])
                type: (classPropertiesDict at: 'type' ifAbsent: [ 'normal' ]) asSymbol
                comment: classComment
                commentStamp: (classPropertiesDict at: 'commentStamp' ifAbsent: [ '' ]))! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'CamilloBruni 8/2/2012 16:28'!
addExtensionClassAndMethodDefinitionsFromEntry: classEntry
    | classDirectory classPropertiesDict methodPropertiesDict entries |

    classDirectory := classEntry asFileReference.

    ((entries := classDirectory entries) detect: [ :entry | entry basename = 'properties.json' ] ifNone: [  ])
        ifNotNil: [ :propertyEntry | 
			propertyEntry asFileReference readStreamDo: [ :fileStream | 
				classPropertiesDict := MCFileTreeJsonParser parseStream: fileStream ]].

    methodPropertiesDict := Dictionary new.
    (entries detect: [ :entry | entry basename = 'methodProperties.json' ] ifNone: [  ])
        ifNotNil: [ :propertyEntry | 
            propertyEntry asFileReference
                readStreamDo: [ :fileStream | 
                    "Issue 33: https://github.com/dalehenrich/filetree/issues/33"
                    methodPropertiesDict := MCFileTreeJsonParser parseStream: fileStream ]].
    self
        addMethodDefinitionsForClass: (classPropertiesDict at: 'name')
        methodProperties: methodPropertiesDict
        in: entries! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:38'!
addMethodDefinitionForClass: className methodProperties: methodProperties entry: entry
	| classIsMeta |
	
	(#( 'instance' 'class') includes: entry basename)
		ifFalse: [ ^ self "unknown entry"].
		
	classIsMeta := entry basename = 'class'.
	
	entry asFileReference files 
		select: [ :each | each basename endsWith: '.st' ]
		thenDo: [ :methodFile | 
			methodFile readStreamDo: [ :fileStream | 
				self 
					loadMethodDefinitionForClass: className 
					classIsMeta: classIsMeta
					methodProperties: methodProperties 
					entry: entry
					fileStream: fileStream ]]! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:38'!
addMethodDefinitionsForClass: className methodProperties: methodProperties in: entries
	entries do: [ :entry | 
		self 
			addMethodDefinitionForClass: className 
			methodProperties: methodProperties 
			entry: entry ]! !

!MCFileTreeStCypressReader methodsFor: 'accessing' stamp: 'dkh 6/27/2012 20:19'!
basicVersion
    self hasMonticelloMetadata
        ifTrue: [ ^ super basicVersion ].
    ^ MCVersion new
        setPackage: self package
            info: self info
            snapshot: self snapshot
            dependencies: #();
        yourself! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:37'!
loadDefinitions
	| entries directory |
	definitions := OrderedCollection new.
	directory := self packageDirectory / self monticelloMetaDirName.

	directory exists
		ifFalse: [ ^ self addClassAndMethodDefinitionsFromDirectory: self packageDirectory].
		
	entries := directory entries.
	self
		addDefinitionFromFile: (entries detect: [ :entry | entry basename beginsWith: 'categories' ] ifNone: [  ])
		inDirectory: directory.
	self addClassAndMethodDefinitionsFromDirectory: self packageDirectory.
	self
		addDefinitionFromFile: (entries detect: [ :entry | entry basename beginsWith: 'initializers' ] ifNone: [  ])
		inDirectory: directory! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'CamilloBruni 8/2/2012 16:26'!
loadMethodDefinitionForClass: className classIsMeta: classIsMeta methodProperties: methodProperties entry: entry fileStream: fileStream
	| category source timestamp selector |
	category := fileStream nextLine.
	source := fileStream upToEnd.
	selector := self methodSelectorFor: source.
	timestamp := methodProperties
		at: entry basename
		ifPresent: [ :map | 
			map at: selector asString ifAbsent: [  ] ].	"Issue 33: https://github.com/dalehenrich/filetree/issues/33"
	timestamp
		ifNil: [ timestamp := self info author , ' ' , self info date mmddyyyy , ' ' , self info time print24 ].
	definitions
		add:
			(MCMethodDefinition
				className: className
				classIsMeta: classIsMeta
				selector: selector
				category: category
				timeStamp: timestamp
				source: source) ! !

!MCFileTreeStCypressReader methodsFor: 'accessing' stamp: 'dkh 6/27/2012 20:21'!
loadPackage
    self hasMonticelloMetadata
        ifTrue: [ ^ super loadPackage ].
    package := MCPackage named: self packageNameFromPackageDirectory! !

!MCFileTreeStCypressReader methodsFor: 'accessing' stamp: 'dkh 6/27/2012 20:21'!
loadVersionInfo
    self hasMonticelloMetadata
        ifTrue: [ ^ info := self extractInfoFrom: (self parseMember: 'version') ].
    info := MCVersionInfo
        name: self packageNameFromPackageDirectory , '-cypress.1'
        id: nil
        message: 'fabricated from a Cypress format repository'
        date: nil
        time: nil
        author: ''
        ancestors: #()
        stepChildren: #()! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 4/4/2012 11:29'!
methodSelectorFor: source
    ^ Object parserClass new parseSelector: source! !

!MCFileTreeStCypressReader methodsFor: 'accessing' stamp: 'CamilloBruni 8/2/2012 15:46'!
packageNameFromPackageDirectory
    | filename |
    filename := self packageDirectory basename.
    ^ filename copyFrom: 1 to: (filename lastIndexOf: $.) - 1! !

!MCFileTreeStSnapshotReader class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 12:06'!
extension
    ^ 'pkg'! !

!MCFileTreeStSnapshotReader methodsFor: 'utilities' stamp: 'CAmilloBruni 8/2/2012 18:46'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    | snapshot classes entries extensions |
    snapshot := aDirectory / 'snapshot'.
    classes := snapshot / 'classes'.
    classes exists
        ifTrue: [ 
            self addClassAndMethodDefinitionsFromDirectoryEntries: (entries := classes entries).	"load .st files from subdirectories (*.class) of snapshot/classes ... class defintions"
            entries
                do: [ :classDirectoryEntry | 
                    | classDirectory |
                    classDirectory := classDirectoryEntry asFileReference.
                    self addClassAndMethodDefinitionsFromDirectoryEntries: classDirectory entries	"load .st files from subdirectories (class or instance) of snapshot/classes/*.class ... method definitions" ] ].
    extensions := snapshot / 'extensions'.
    extensions exists
        ifTrue: [ 
           extensions entries
                do: [ :classDirectoryEntry | 
                    | classDirectory |
                    classDirectory := classDirectoryEntry asFileReference.
                    self addClassAndMethodDefinitionsFromDirectoryEntries: classDirectory entries	"load .st files from subdirectories (class or instance) of snapshot/extensions/*.class ... method definitions" ] ].
! !

!Array methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    | indent |
    aStream
        nextPutAll: '[';
        lf.
    indent := startIndent + 1.
    1 to: self size do: [ :index | 
        | item |
        item := self at: index.
        aStream tab: indent.
        item writeCypressJsonOn: aStream forHtml: forHtml indent: indent.
        index < self size
            ifTrue: [ 
                aStream
                    nextPutAll: ',';
                    lf ] ].
    self size = 0
        ifTrue: [ aStream tab: indent ].
    aStream nextPutAll: ' ]'! !

MCMczWriter subclass: #MCFileTreeWriter
	instanceVariableNames: 'directory packageFileDirectory cachedPackageFileDirectoryEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeWriter class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 13:09'!
readerClass
    "don't expect this message to be sent"

    self shouldNotImplement! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'CAmilloBruni 8/2/2012 18:48'!
addString: string at: fileName
    | path |
    path := MCFileTreePackageStructureStWriter useCypressWriter
        ifTrue: [ |dir|
            dir := (self packageFileDirectory /  MCFileTreeStCypressWriter monticelloMetaDirName) ensureDirectory.
		dir := dir resolve: fileName.
		dir parent ensureDirectory.
            dir fullName ]
        ifFalse: [ fileName ].

    string isEmpty 
		ifFalse: [ 
			(self packageFileDirectory resolve: path) writeStreamDo: [ :aStream | aStream nextPutAll: string ]]! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'CamilloBruni 9/15/2012 01:20'!
deleteExistingPackageStructureFor: members
    "destroy .tree and .pkg directory structure .. otherwise it won't be pretty"

    | alternateDirName alternateDir |
    self packageFileDirectory exists
        ifTrue: [ self packageFileDirectory deleteAll ].
    alternateDirName := (self packageFileDirectory basename endsWith: '.pkg')
        ifTrue: [ members first , '.tree' ]
        ifFalse: [ 
            (self packageFileDirectory basename endsWith: '.tree')
                ifTrue: [ members first , '.pkg' ]
                ifFalse: [ 
                    (self packageFileDirectory basename endsWith: '.package')
                        ifTrue: [ members first , '.pkg' ] ] ].
    alternateDirName
        ifNotNil: [ 
            alternateDir := stream directory / alternateDirName.
            alternateDir exists
                ifTrue: [ alternateDir deleteAll ]]! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'dkh 2/16/2012 14:49:00'!
flush
	! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'CAmilloBruni 8/2/2012 18:36'!
initializePackageFileDirectoryCache
	cachedPackageFileDirectoryEntries := Dictionary new.
	self packageFileDirectory entries
		do: [ :entry | 
			entry isDirectory
				ifTrue: [ cachedPackageFileDirectoryEntries at: entry basename put: entry asFileReference ] ]! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'CAmilloBruni 8/2/2012 18:45'!
packageFileDirectory
    packageFileDirectory ifNil: [ packageFileDirectory := stream directory / directory ].
    ^ packageFileDirectory! !

!MCFileTreeWriter methodsFor: 'accessing' stamp: 'dkh 2/29/2012 13:59'!
snapshotWriterClass
	^ MCFileTreeAbstractStWriter! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'CAmilloBruni 8/2/2012 18:23'!
subPackageFileDirectoryFor: directoryNameOrPath
    ^ cachedPackageFileDirectoryEntries
        at: directoryNameOrPath
        ifAbsentPut: [ 
            | dir |
            dir := self packageFileDirectory resolve: directoryNameOrPath.
            dir ensureDirectory.
            dir ]! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 2/16/2012 14:49:00'!
writeSnapshot: aSnapshot
	(self snapshotWriterClass on: self) writeDefinitions: aSnapshot definitions! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'CAmilloBruni 8/2/2012 18:27'!
writeVersion: aVersion
    | members |
    directory := (members := MCFileTreeRepository parseName: aVersion info name) last.
    self deleteExistingPackageStructureFor: members.
    self packageFileDirectory ensureDirectory.
    self initializePackageFileDirectoryCache.
    super writeVersion: aVersion! !

!Boolean methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    aStream nextPutAll: self printString! !

MCDirectoryRepository subclass: #MCFileTreeRepository
	instanceVariableNames: 'readonly repositoryProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeRepository class
	instanceVariableNames: 'defaultPackageExtension'!

MCFileTreeRepository class
	instanceVariableNames: 'defaultPackageExtension'!

!MCFileTreeRepository class methodsFor: 'accessing' stamp: 'dkh 4/4/2012 14:27'!
defaultPackageExtension
    ".tree, .pkg, .package are the only formats supported at the moment:
	.tree         - original structure
	.pkg          - snapshot structure
	.package - cypress structure"

    defaultPackageExtension
        ifNil: [ 
            defaultPackageExtension := MCFileTreePackageStructureStWriter useCypressWriter
                ifTrue: [ '.package' ]
                ifFalse: [ '.pkg' ] ].
    ^ defaultPackageExtension! !

!MCFileTreeRepository class methodsFor: 'accessing' stamp: 'dkh 4/4/2012 14:36'!
defaultPackageExtension: aString
    ".tree and .pkg are the only two formats supported at the moment"

    "self defaultPackageExtension:'.package'"

    (#('.tree' '.pkg' '.package') includes: aString)
        ifFalse: [ self error: 'Unsupported package extension: ' , aString printString ].
    defaultPackageExtension := aString! !

!MCFileTreeRepository class methodsFor: 'instance creation' stamp: 'dkh 2/16/2012 14:49:00'!
description
    ^ 'filetree://'! !

!MCFileTreeRepository class methodsFor: 'utility' stamp: 'dkh 2/29/2012 09:40:37'!
parseName: aString
    ^ self parseName: aString extension: self defaultPackageExtension! !

!MCFileTreeRepository class methodsFor: 'utility' stamp: 'dkh 2/16/2012 14:49:00'!
parseName: aString extension: extension
    "picked up from GoferVersionReference>>parseName:"

    | info basicName package branch author versionNumber packageName |
    basicName := aString last isDigit
        ifTrue: [ aString ]
        ifFalse: [ (aString copyUpToLast: $.) copyUpTo: $( ].
    package := basicName copyUpToLast: $-.
    (package includes: $.)
        ifFalse: [ branch := '' ]
        ifTrue: [ 
            branch := '.' , (package copyAfter: $.).
            package := package copyUpTo: $. ].
    author := (basicName copyAfterLast: $-) copyUpToLast: $..
    versionNumber := (basicName copyAfterLast: $-) copyAfterLast: $..
    (versionNumber notEmpty and: [ versionNumber allSatisfy: [ :each | each isDigit ] ])
        ifTrue: [ versionNumber := versionNumber asNumber ]
        ifFalse: [ versionNumber := 0 ].
    packageName := package , branch.
    ^ {packageName.
    author.
    versionNumber.
    (packageName , extension)}! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 7/6/2012 10:23'!
allFileNamesForVersionNamed: aString
	^ self filterFileNames: self readableFileNames forVersionNamed: aString! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 2/16/2012 14:49:00'!
asRepositorySpecFor: aMetacelloMCProject
    ^ aMetacelloMCProject repositorySpec
        description: self description;
        type: 'filetree';
        yourself! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 4/5/2012 10:33'!
basicStoreVersion: aVersion
    self readonly
        ifTrue: [ ^ self error: 'The filetree repository: ' , self description printString , ' was created read only.' ].
    self packageExtension ~= self class defaultPackageExtension
        ifTrue: [ 
            repositoryProperties := nil.	"force reset of properties, since we're rewriting the file"
            self writeRepositoryProperties ].
    MCFileTreeWriter fileOut: aVersion on: self! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 2/16/2012 14:49:00'!
cachedFileNames
	^ #()! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 6/28/2012 15:14'!
canReadFileNamed: aString
    ^ (aString endsWith: self packageExtension)
        or: [ 
            (aString endsWith: '.tree')
                or: [ 
                    "Cypress format"
                    aString endsWith: '.package' ] ]! !

!MCFileTreeRepository methodsFor: 'descriptions' stamp: 'dkh 2/16/2012 14:49:00'!
description
    ^ self class description , super description! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/7/2012 17:09:47'!
directory: aDirectory
    super directory: aDirectory.
    self repositoryProperties isEmpty
        ifTrue: [ 
            aDirectory exists
                ifTrue: [ self writeRepositoryProperties ] ]! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'CamilloBruni 8/2/2012 15:28'!
fileDirectoryOn: fileName
    ^ self directory / fileName! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'CAmilloBruni 8/2/2012 18:48'!
goferVersionFrom: aVersionReference
    "until we no longer find .tree directories in the wild"

    ((self readableFileNames collect: [ :fileName | self fileDirectoryOn: fileName ])
        select: [ :packageDirectory | packageDirectory exists ])
        collect: [ :packageDirectory | 
            (self versionInfoForPackageDirectory: packageDirectory) name = aVersionReference name
                ifTrue: [ ^ self loadVersionFromFileNamed: packageDirectory basename ] ].
    ^ nil! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/2/2012 15:37'!
loadAllFileNames
    ^ self directory directories collect: #basename! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'CamilloBruni 8/2/2012 15:39'!
packageDescriptionFromPackageDirectory: packageDirectory
    | filename info extension |
    filename := packageDirectory basename.
    extension := packageDirectory extension.
    ^ ((self packageExtension ~= 'package'
        and: [ (packageDirectory / 'version') exists and: [ (packageDirectory/ 'package') exists ] ])
        or: [ (packageDirectory / MCFileTreeStCypressWriter monticelloMetaDirName) exists ])
        ifTrue: [ 
            info := self versionInfoForPackageDirectory: packageDirectory.
            self parseName: info name extension: extension ]
        ifFalse: [ 
            {(filename copyFrom: 1 to: (filename lastIndexOf: $.) - 1).
            'cypress'.
            1.
            filename} ]! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'dkh 2/16/2012 14:49:00'!
packageDescriptionsFromReadableFileNames
	^ ((self readableFileNames collect: [ :fileName | self fileDirectoryOn: fileName ])
		select: [ :packageDirectory | packageDirectory exists ])
		collect: [ :packageDirectory | self packageDescriptionFromPackageDirectory: packageDirectory ]! !

!MCFileTreeRepository methodsFor: 'private' stamp: 'dkh 2/29/2012 10:11'!
packageExtension
    ^ self repositoryProperties at: 'packageExtension' ifAbsent: [ '.tree' ]! !

!MCFileTreeRepository methodsFor: 'private' stamp: 'dkh 2/29/2012 11:39'!
parseName: aString extension: extension
    ^ self class parseName: aString extension: extension! !

!MCFileTreeRepository methodsFor: 'i/o' stamp: 'dkh 6/16/2012 09:02'!
readStreamForFileNamed: aString do: aBlock
    ^ aBlock value: self directory! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 2/16/2012 14:49:00'!
readonly
    readonly ifNil: [ readonly := false ].
    ^ readonly! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 2/16/2012 14:49:00'!
readonly: anObject
	readonly := anObject! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'CamilloBruni 9/15/2012 01:18'!
repositoryProperties
	| configEntry |
    repositoryProperties
        ifNil: [ 
            repositoryProperties := Dictionary new.
            self directory exists
                ifFalse: [ 
                    Transcript
                        cr;
                        show: 'filetree:// repository ' , self directory pathName printString , ' does not exist.'.
                    ^ repositoryProperties ].
            (configEntry := (self directory / '.filetree')) exists
			ifTrue: [ 
                    configEntry readStreamDo: [ :fileStream | 
                     	repositoryProperties := MCFileTreeJsonParser parseStream: fileStream ]]].
    ^ repositoryProperties! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 2/16/2012 14:49:00'!
versionFromFileNamed: aString
	^ self loadVersionFromFileNamed: aString! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'CamilloBruni 8/2/2012 15:42'!
versionInfoForPackageDirectory: packageDirectory
    ^ ((MCReader readerClassForFileNamed: packageDirectory basename)
        on: packageDirectory)
        loadVersionInfo;
        info! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 2/16/2012 14:49:00'!
versionInfoFromFileNamed: aString
	^ self loadVersionInfoFromFileNamed: aString! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 2/16/2012 14:49:00'!
versionNameFromFileName: aString
	| description |
	description := self packageDescriptionFromPackageDirectory: (self fileDirectoryOn: aString).
	^ description first , '-' , description second , '.' , description third printString! !

!MCFileTreeRepository methodsFor: 'interface' stamp: 'dkh 2/16/2012 14:49:00'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	(self allFileNamesForVersionNamed: aVersionInfo name)
		ifNotEmpty: [ :aCollection | ^ self versionFromFileNamed: aCollection first ].
	^ errorBlock value! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/2/2012 15:27'!
writeRepositoryProperties
    (self directory / '.filetree') 
		writeStreamDo: [ :stream | 
       	stream 
				lineEndConvention: #'lf';
   				nextPutAll: '{ "packageExtension" : "';
				nextPutAll: self class defaultPackageExtension;
				nextPutAll: '" }'; cr ]! !

!MCFileTreeRepository methodsFor: 'i/o' stamp: 'dkh 2/16/2012 14:49:00'!
writeStreamForFileNamed: aString replace: aBoolean do: aBlock
	self error: 'we do not open a single stream, but write multiple files'! !

MCStWriter subclass: #MCFileTreePackageStructureStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreePackageStructureStWriter class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 10:37'!
useCypressWriter
    "MCFileTreeRepository defaultPackageExtension:'.package'"

    "MCFileTreeRepository defaultPackageExtension:'.pkg'"

    ^ true! !

!MCFileTreePackageStructureStWriter class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 10:30'!
useSnapShotWriter
    ^ MCFileTreeRepository defaultPackageExtension = '.pkg'! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 2/29/2012 13:46'!
absentInitializers
	^ initializers reject: [ :each | Smalltalk hasClassNamed: each key ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'visiting' stamp: 'dkh 2/29/2012 13:46'!
acceptVisitor: aVisitor forDefinitions: aCollection
	(MCDependencySorter sortItems: aCollection)
		do: [ :ea | ea accept: aVisitor ]
		displayingProgress: 'Writing definitions...'! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 2/29/2012 13:45'!
initializers: aCollection
	initializers := aCollection! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 2/29/2012 13:46'!
presentInitializers
	^ initializers select: [ :each | Smalltalk hasClassNamed: each key ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 2/29/2012 13:45'!
writeAbsentInitializers
	(self absentInitializers asSortedCollection: [ :a :b | a key <= b key ])
		do: [ :association | stream nextPutAll: association value contents ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 2/29/2012 14:48'!
writeClassDefinition: definition
    self chunkContents: [ :s | definition printDefinitionOn: s ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 2/29/2012 13:42'!
writeDefinitions: aCollection
	"the correct initialization order is unknown if some classes are missing in the image"

	initializers := Set new.
	self
		acceptVisitor: self forDefinitions: aCollection;
		writePresentInitializers;
		writeAbsentInitializers! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 2/16/2012 14:49:00'!
writeMethodPreamble: definition
    stream
        cr;
        nextPut: $!!;
        nextPutAll: definition fullClassName;
        nextPutAll: ' methodsFor: ';
        nextPutAll: definition category asString printString;
        nextPutAll: '!!';
        cr! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 2/29/2012 13:45'!
writePresentInitializers
	| orderedClasses presentInitializers |
	presentInitializers := self presentInitializers.
	orderedClasses := (Class
		superclassOrder: (presentInitializers collect: [ :each | Smalltalk classOrTraitNamed: each key ]))
		collect: [ :each | each name ].
	orderedClasses
		do: [ :className | stream nextPutAll: (presentInitializers detect: [ :each | each key = className ]) value contents ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:21'!
writeProperties
    stream
        nextPut: ${;
        cr;
        nextPutAll: '    "noMethodMetaData" : true,';
        cr;
        nextPutAll: '    "separateMethodMetaAndSource" : false';
        cr;
        nextPut: $};
        cr! !

Object subclass: #MCFileTreeJsonParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeJsonParser class methodsFor: 'instance creation' stamp: 'dkh 2/16/2012 14:39:25'!
new
	self error: 'Instantiate the parser with a stream.'! !

!MCFileTreeJsonParser class methodsFor: 'instance creation' stamp: 'dkh 2/16/2012 14:39:25'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!MCFileTreeJsonParser class methodsFor: 'accessing' stamp: 'dkh 2/16/2012 14:39:25'!
parse: aString
	^ self parseStream: aString readStream! !

!MCFileTreeJsonParser class methodsFor: 'accessing' stamp: 'dkh 2/16/2012 14:39:25'!
parseStream: aStream
	^ (self on: aStream) parse! !

!MCFileTreeJsonParser methodsFor: 'adding' stamp: 'dkh 2/16/2012 14:39:25'!
addProperty: anAssociation to: anObject
	"Add the property anAssociation described with key and value to anObject. Subclasses might want to refine this implementation."
	
	^ anObject 
		add: anAssociation;
		yourself! !

!MCFileTreeJsonParser methodsFor: 'adding' stamp: 'dkh 2/16/2012 14:39:25'!
addValue: anObject to: aCollection
	"Add anObject to aCollection. Subclasses might want to refine this implementation."

	^ aCollection copyWith: anObject! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 2/16/2012 14:39:25'!
createArray
	"Create an empty collection. Subclasses might want to refine this implementation."

	^ Array new! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 2/16/2012 14:39:25'!
createFalse
	"Create the false literal. Subclasses might want to refine this implementation."
	
	^ false! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 2/16/2012 14:39:25'!
createNull
	"Create the null literal. Subclasses might want to refine this implementation."

	^ nil! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 2/16/2012 14:39:25'!
createNumber: aString
	"Create a number literal. Subclasses might want to refine this implementation."

	^ aString asNumber! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 2/16/2012 14:39:25'!
createObject
	"Create an empty object. Subclasses might want to refine this implementation."
	
	^ Dictionary new! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 2/16/2012 14:39:25'!
createProperty: aKey with: aValue
	"Create an empty attribute value pair. Subclasses might want to refine this implementation."
	
	^ aKey -> aValue! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 2/16/2012 14:39:25'!
createString: aString
	"Create a string literal. Subclasses might want to refine this implementation."

	^ aString! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 2/16/2012 14:39:25'!
createTrue
	"Create the true literal. Subclasses might want to refine this implementation."

	^ true! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 2/16/2012 14:39:25'!
expect: aString
	"Expects aString and consume input, throw an error otherwise."

	^ (self match: aString) ifFalse: [ self error: aString , ' expected' ]! !

!MCFileTreeJsonParser methodsFor: 'initialization' stamp: 'dkh 2/16/2012 14:39:25'!
initializeOn: aStream
	self initialize.
	stream := aStream! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 2/16/2012 14:39:25'!
match: aString
	"Tries to match aString, consume input and answer true if successful."
	
	| position |
	position := stream position.
	aString do: [ :each |
		(stream atEnd or: [ stream next ~= each ]) ifTrue: [ 
			stream position: position.
			^ false ] ].
	self whitespace.
	^ true! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 2/16/2012 14:39:25'!
parse
	| result |
	result := self whitespace; parseValue.
	stream atEnd
		ifFalse: [ self error: 'end of input expected' ].
	^ result! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 2/16/2012 14:39:25'!
parseArray
	| result |
	self expect: '['.
	result := self createArray.
	(self match: ']')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addValue: self parseValue
			to: result.
		(self match: ']') 
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of array expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 2/16/2012 14:39:25'!
parseCharacter
	| char |
	(char := stream next) = $\ 
		ifFalse: [ ^ char ].
	(char := stream next) = $" 
		ifTrue: [ ^ char ].
	char = $\
		ifTrue: [ ^ char ].
	char = $/
		ifTrue: [ ^ char ].
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 2/16/2012 14:39:25'!
parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/6/2012 15:56:14'!
parseCharacterHexDigit
    | digit |
    stream atEnd
        ifFalse: [ 
            digit := stream next charCode.
            (digit between: 48 and: 57)
                ifTrue: [ ^ digit - 48 ].	"$0"	"$9"
            (digit between: 65 and: 70)
                ifTrue: [ ^ digit - 55 ].	"$A"	"$F"
            (digit between: 97 and: 102)
                ifTrue: [ ^ digit - 87 ]	"$a"	"$f" ].
    self error: 'hex-digit expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 2/16/2012 14:39:25'!
parseNumber
	| negated number |
	negated := stream peek = $-.
	negated ifTrue: [ stream next ].
	number := self parseNumberInteger.
	(stream peek = $.) ifTrue: [
		stream next. 
		number := number + self parseNumberFraction ].
	(stream peek = $e or: [ stream peek = $E ]) ifTrue: [
		stream next.
		number := number * self parseNumberExponent ].
	negated ifTrue: [ number := number negated ].
	^ self whitespace; createNumber: number! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/6/2012 15:56:14'!
parseNumberExponent
    | number negated |
    number := 0.
    negated := stream peek = $-.
    (negated or: [ stream peek = $+ ])
        ifTrue: [ stream next ].
    [ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [ number := 10 * number + (stream next charCode - 48) ].
    negated
        ifTrue: [ number := number negated ].
    ^ 10 raisedTo: number! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/6/2012 15:56:14'!
parseNumberFraction
    | number power |
    number := 0.
    power := 1.0.
    [ stream atEnd not and: [ stream peek isDigit ] ]
        whileTrue: [ 
            number := 10 * number + (stream next charCode - 48).
            power := power * 10.0 ].
    ^ number / power! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/6/2012 15:56:14'!
parseNumberInteger
    | number |
    number := 0.
    [ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [ number := 10 * number + (stream next charCode - 48) ].
    ^ number! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 2/16/2012 14:39:25'!
parseObject
	| result |
	self expect: '{'.
	result := self createObject.
	(self match: '}')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addProperty: self parseProperty
			to: result.
		(self match: '}')
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of object expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 2/16/2012 14:39:25'!
parseProperty
	| name value |
	name := self parseString.
	self expect: ':'.
	value := self parseValue.
	^ self createProperty: name with: value.! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 2/16/2012 14:39:25'!
parseString
	| result |
	self expect: '"'.
	result := WriteStream on: String new.
	[ stream atEnd or: [ stream peek = $" ] ] 
		whileFalse: [ result nextPut: self parseCharacter ].
	^ self expect: '"'; createString: result contents! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 2/16/2012 14:39:25'!
parseValue
	| char |
	stream atEnd ifFalse: [ 
		char := stream peek.
		char = ${
			ifTrue: [ ^ self parseObject ].
		char = $[
			ifTrue: [ ^ self parseArray ].
		char = $"
			ifTrue: [ ^ self parseString ].
		(char = $- or: [ char between: $0 and: $9 ])
			ifTrue: [ ^ self parseNumber ].
		(self match: 'true')
			ifTrue: [ ^ self createTrue ].
		(self match: 'false')
			ifTrue: [ ^ self createFalse ].
		(self match: 'null')
			ifTrue: [ ^ self createNull ] ].
	self error: 'invalid input'! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 2/16/2012 14:39:25'!
whitespace
	"Strip whitespaces from the input stream."

	[ stream atEnd not and: [ stream peek isSeparator ] ]
		whileTrue: [ stream next ]! !

!Object methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonForHtmlOn: aStream indent: startIndent
    self writeCypressJsonOn: aStream forHtml: true indent: startIndent! !

!Object methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    ^ self subclassResponsibility! !

!Object methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream indent: startIndent
    self writeCypressJsonOn: aStream forHtml: false indent: startIndent! !

!MCFileBasedRepository methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/5/2012 11:15:15'!
packageDescriptionsFromReadableFileNames
	^ self readableFileNames
		collect: [ :each | 
			| name |
			name := (each copyUpToLast: $.) copyUpTo: $(.
			name last isDigit
				ifFalse: [ 
					{name.
					''.
					''.
					each} ]
				ifTrue: [ 
					| packageName author versionNumber |
					packageName := name copyUpToLast: $-.
					author := (name copyAfterLast: $-) copyUpTo: $..
					versionNumber := ((name copyAfterLast: $-) copyAfter: $.) asInteger ifNil: [ 0 ].
					{packageName.
					author.
					versionNumber.
					each} ] ]! !

!MCFileBasedRepository methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/5/2012 11:15:15'!
retrieveVersionsWithPackageNames: packageNames
	| packageDescriptions |
	packageDescriptions := self packageDescriptionsFromReadableFileNames.
	packageNames addAll: (packageDescriptions collect: [ :packageDescription | packageDescription first ]).
	^ packageDescriptions select: [ :each | (each at: 3) isNumber ]! !

!String methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
cypressEscape
    ^ self encodeForHTTP! !

!String methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
cypressUnescape
    ^ self unescapePercents! !

!String methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    aStream
        nextPutAll: '"';
        nextPutAll:
                (forHtml
                        ifTrue: [ self cypressEscape ]
                        ifFalse: [ self ]);
        nextPutAll: '"'! !
MCFileTreeStCypressWriter initialize!
